Small ChangeLog tweak.
[official-gcc.git] / libgo / mksysinfo.sh
blob1220b3ac617c271e00f0beebb7530754da0c9a4e
1 #!/bin/sh
3 # Copyright 2009 The Go Authors. All rights reserved.
4 # Use of this source code is governed by a BSD-style
5 # license that can be found in the LICENSE file.
7 # Create sysinfo.go from gen-sysinfo.go and errno.i.
9 # This shell script creates the sysinfo.go file which holds types and
10 # constants extracted from the system header files. This reads the
11 # raw data from gen-sysinfo.go which is generated using the
12 # -fdump-go-spec option.
14 # This currently exposes some names that ideally should not be
15 # exposed, as they match grep patterns. E.g., WCHAR_MIN gets exposed
16 # because it starts with W, like the wait flags.
18 OUT=tmp-sysinfo.go
20 set -e
22 echo 'package syscall' > ${OUT}
23 echo 'import "unsafe"' >> ${OUT}
24 echo 'type _ unsafe.Pointer' >> ${OUT}
26 # Get all the consts and types, skipping ones which could not be
27 # represented in Go and ones which we need to rewrite. We also skip
28 # function declarations, as we don't need them here. All the symbols
29 # will all have a leading underscore.
30 grep -v '^// ' gen-sysinfo.go | \
31 grep -v '^func' | \
32 grep -v '^type _timeval ' | \
33 grep -v '^type _timespec_t ' | \
34 grep -v '^type _timespec ' | \
35 grep -v '^type _timestruc_t ' | \
36 grep -v '^type _epoll_' | \
37 grep -v 'in6_addr' | \
38 grep -v 'sockaddr_in6' | \
39 sed -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
40 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
41 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
42 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
43 >> ${OUT}
45 # On AIX, the _arpcom struct, is filtered by the above grep sequence, as it as
46 # a field of type _in6_addr, but other types depend on _arpcom, so we need to
47 # put it back.
48 grep '^type _arpcom ' gen-sysinfo.go | \
49 sed -e 's/_in6_addr/[16]byte/' >> ${OUT}
51 # The errno constants. These get type Errno.
52 egrep '#define E[A-Z0-9_]+ ' errno.i | \
53 sed -e 's/^#define \(E[A-Z0-9_]*\) .*$/const \1 = Errno(_\1)/' >> ${OUT}
55 # The O_xxx flags.
56 egrep '^const _(O|F|FD)_' gen-sysinfo.go | \
57 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
58 if ! grep '^const O_ASYNC' ${OUT} >/dev/null 2>&1; then
59 echo "const O_ASYNC = 0" >> ${OUT}
61 if ! grep '^const O_CLOEXEC' ${OUT} >/dev/null 2>&1; then
62 echo "const O_CLOEXEC = 0" >> ${OUT}
65 # The os package requires F_DUPFD_CLOEXEC to be defined.
66 if ! grep '^const F_DUPFD_CLOEXEC' ${OUT} >/dev/null 2>&1; then
67 echo "const F_DUPFD_CLOEXEC = 0" >> ${OUT}
70 # AIX 7.1 is a 64 bits value for _FCLOEXEC (referenced by O_CLOEXEC)
71 # which leads to a constant overflow when using O_CLOEXEC in some
72 # go code. Issue wan not present in 6.1 (no O_CLOEXEC) and is no
73 # more present in 7.2 (_FCLOEXEC is a 32 bit value).
74 if test "${GOOS}" = "aix" && `oslevel | grep -q "^7.1"`; then
75 sed -e 's/const __FCLOEXEC = .*/const __FCLOEXEC = 0/' ${OUT} > ${OUT}-2
76 mv ${OUT}-2 ${OUT}
79 # These flags can be lost on i386 GNU/Linux when using
80 # -D_FILE_OFFSET_BITS=64, because we see "#define F_SETLK F_SETLK64"
81 # before we see the definition of F_SETLK64.
82 for flag in F_GETLK F_SETLK F_SETLKW; do
83 if ! grep "^const ${flag} " ${OUT} >/dev/null 2>&1 \
84 && grep "^const ${flag}64 " ${OUT} >/dev/null 2>&1; then
85 echo "const ${flag} = ${flag}64" >> ${OUT}
87 done
89 # The Flock_t struct for fcntl.
90 grep '^type _flock ' gen-sysinfo.go | \
91 sed -e 's/type _flock/type Flock_t/' \
92 -e 's/l_type/Type/' \
93 -e 's/l_whence/Whence/' \
94 -e 's/l_start/Start/' \
95 -e 's/l_len/Len/' \
96 -e 's/l_pid/Pid/' \
97 >> ${OUT}
99 # The signal numbers.
100 grep '^const _SIG[^_]' gen-sysinfo.go | \
101 grep -v '^const _SIGEV_' | \
102 sed -e 's/^\(const \)_\(SIG[^= ]*\)\(.*\)$/\1\2 = Signal(_\2)/' >> ${OUT}
103 if ! grep '^const SIGPOLL ' ${OUT} >/dev/null 2>&1; then
104 if grep '^const SIGIO ' ${OUT} > /dev/null 2>&1; then
105 echo "const SIGPOLL = SIGIO" >> ${OUT}
108 if ! grep '^const SIGCLD ' ${OUT} >/dev/null 2>&1; then
109 if grep '^const SIGCHLD ' ${OUT} >/dev/null 2>&1; then
110 echo "const SIGCLD = SIGCHLD" >> ${OUT}
114 # The syscall numbers. We force the names to upper case.
115 grep '^const _SYS_' gen-sysinfo.go | \
116 sed -e 's/const _\(SYS_[^= ]*\).*$/\1/' | \
117 while read sys; do
118 sup=`echo $sys | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
119 echo "const $sup = _$sys" >> ${OUT}
120 done
122 # The GNU/Linux support wants to use SYS_GETDENTS64 if available.
123 if ! grep '^const SYS_GETDENTS ' ${OUT} >/dev/null 2>&1; then
124 echo "const SYS_GETDENTS = 0" >> ${OUT}
126 if ! grep '^const SYS_GETDENTS64 ' ${OUT} >/dev/null 2>&1; then
127 echo "const SYS_GETDENTS64 = 0" >> ${OUT}
130 # Stat constants.
131 grep '^const _S_' gen-sysinfo.go | \
132 sed -e 's/^\(const \)_\(S_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
134 # Mmap constants.
135 grep '^const _PROT_' gen-sysinfo.go | \
136 sed -e 's/^\(const \)_\(PROT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
137 grep '^const _MAP_' gen-sysinfo.go | \
138 sed -e 's/^\(const \)_\(MAP_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
139 grep '^const _MADV_' gen-sysinfo.go | \
140 sed -e 's/^\(const \)_\(MADV_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
141 grep '^const _MCL_' gen-sysinfo.go | \
142 sed -e 's/^\(const \)_\(MCL_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
144 # Process status constants.
145 grep '^const _W' gen-sysinfo.go |
146 sed -e 's/^\(const \)_\(W[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
147 # WSTOPPED was introduced in glibc 2.3.4.
148 if ! grep '^const _WSTOPPED = ' gen-sysinfo.go >/dev/null 2>&1; then
149 if grep '^const _WUNTRACED = ' gen-sysinfo.go > /dev/null 2>&1; then
150 echo 'const WSTOPPED = _WUNTRACED' >> ${OUT}
151 else
152 echo 'const WSTOPPED = 2' >> ${OUT}
155 if grep '^const ___WALL = ' gen-sysinfo.go >/dev/null 2>&1 \
156 && ! grep '^const _WALL = ' gen-sysinfo.go >/dev/null 2>&1; then
157 echo 'const WALL = ___WALL' >> ${OUT}
160 # Networking constants.
161 egrep '^const _(AF|ARPHRD|ETH|IN|SOCK|SOL|SO|IPPROTO|TCP|IP|IPV6)_' gen-sysinfo.go |
162 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
163 grep '^const _SOMAXCONN' gen-sysinfo.go |
164 sed -e 's/^\(const \)_\(SOMAXCONN[^= ]*\)\(.*\)$/\1\2 = _\2/' \
165 >> ${OUT}
166 grep '^const _SHUT_' gen-sysinfo.go |
167 sed -e 's/^\(const \)_\(SHUT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
169 # The net package requires some const definitions.
170 for m in IP_PKTINFO IPV6_V6ONLY IPPROTO_IPV6 IPV6_JOIN_GROUP IPV6_LEAVE_GROUP IPV6_TCLASS SO_REUSEPORT; do
171 if ! grep "^const $m " ${OUT} >/dev/null 2>&1; then
172 echo "const $m = 0" >> ${OUT}
174 done
175 for m in SOCK_CLOEXEC SOCK_NONBLOCK; do
176 if ! grep "^const $m " ${OUT} >/dev/null 2>&1; then
177 echo "const $m = -1" >> ${OUT}
179 done
181 # The syscall package requires AF_LOCAL.
182 if ! grep '^const AF_LOCAL ' ${OUT} >/dev/null 2>&1; then
183 if grep '^const AF_UNIX ' ${OUT} >/dev/null 2>&1; then
184 echo "const AF_LOCAL = AF_UNIX" >> ${OUT}
188 # sysconf constants.
189 grep '^const __SC' gen-sysinfo.go |
190 sed -e 's/^\(const \)__\(SC[^= ]*\)\(.*\)$/\1\2 = __\2/' >> ${OUT}
192 # pathconf constants.
193 grep '^const __PC' gen-sysinfo.go |
194 sed -e 's/^\(const \)__\(PC[^= ]*\)\(.*\)$/\1\2 = __\2/' >> ${OUT}
196 # The PATH_MAX constant.
197 if grep '^const _PATH_MAX ' gen-sysinfo.go >/dev/null 2>&1; then
198 echo 'const PathMax = _PATH_MAX' >> ${OUT}
201 # epoll constants.
202 grep '^const _EPOLL' gen-sysinfo.go |
203 grep -v EPOLLET |
204 sed -e 's/^\(const \)_\(EPOLL[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
205 # Make sure EPOLLET is positive.
206 if grep '^const _EPOLLET = [0-9]' gen-sysinfo.go >/dev/null 2>&1; then
207 grep '^const _EPOLLET ' gen-sysinfo.go |
208 sed -e 's/^\(const \)_\(EPOLL[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
209 else
210 echo "const EPOLLET = 0x80000000" >> ${OUT}
212 # Make sure EPOLLRDHUP and EPOLL_CLOEXEC are defined.
213 if ! grep '^const EPOLLRDHUP' ${OUT} >/dev/null 2>&1; then
214 echo "const EPOLLRDHUP = 0x2000" >> ${OUT}
216 if ! grep '^const EPOLL_CLOEXEC' ${OUT} >/dev/null 2>&1; then
217 echo "const EPOLL_CLOEXEC = 02000000" >> ${OUT}
220 # Prctl constants.
221 grep '^const _PR_' gen-sysinfo.go |
222 sed -e 's/^\(const \)_\(PR_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
224 # Ptrace constants.
225 grep '^const _PTRACE' gen-sysinfo.go |
226 sed -e 's/^\(const \)_\(PTRACE[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
227 # We need some ptrace options that are not defined in older versions
228 # of glibc.
229 if ! grep '^const PTRACE_SETOPTIONS' ${OUT} > /dev/null 2>&1; then
230 echo "const PTRACE_SETOPTIONS = 0x4200" >> ${OUT}
232 if ! grep '^const PTRACE_O_TRACESYSGOOD' ${OUT} > /dev/null 2>&1; then
233 echo "const PTRACE_O_TRACESYSGOOD = 0x1" >> ${OUT}
235 if ! grep '^const PTRACE_O_TRACEFORK' ${OUT} > /dev/null 2>&1; then
236 echo "const PTRACE_O_TRACEFORK = 0x2" >> ${OUT}
238 if ! grep '^const PTRACE_O_TRACEVFORK' ${OUT} > /dev/null 2>&1; then
239 echo "const PTRACE_O_TRACEVFORK = 0x4" >> ${OUT}
241 if ! grep '^const PTRACE_O_TRACECLONE' ${OUT} > /dev/null 2>&1; then
242 echo "const PTRACE_O_TRACECLONE = 0x8" >> ${OUT}
244 if ! grep '^const PTRACE_O_TRACEEXEC' ${OUT} > /dev/null 2>&1; then
245 echo "const PTRACE_O_TRACEEXEC = 0x10" >> ${OUT}
247 if ! grep '^const PTRACE_O_TRACEVFORKDONE' ${OUT} > /dev/null 2>&1; then
248 echo "const PTRACE_O_TRACEVFORKDONE = 0x20" >> ${OUT}
250 if ! grep '^const PTRACE_O_TRACEEXIT' ${OUT} > /dev/null 2>&1; then
251 echo "const PTRACE_O_TRACEEXIT = 0x40" >> ${OUT}
253 if ! grep '^const PTRACE_O_MASK' ${OUT} > /dev/null 2>&1; then
254 echo "const PTRACE_O_MASK = 0x7f" >> ${OUT}
256 if ! grep '^const _PTRACE_GETEVENTMSG' ${OUT} > /dev/null 2>&1; then
257 echo "const PTRACE_GETEVENTMSG = 0x4201" >> ${OUT}
259 if ! grep '^const PTRACE_EVENT_FORK' ${OUT} > /dev/null 2>&1; then
260 echo "const PTRACE_EVENT_FORK = 1" >> ${OUT}
262 if ! grep '^const PTRACE_EVENT_VFORK' ${OUT} > /dev/null 2>&1; then
263 echo "const PTRACE_EVENT_VFORK = 2" >> ${OUT}
265 if ! grep '^const PTRACE_EVENT_CLONE' ${OUT} > /dev/null 2>&1; then
266 echo "const PTRACE_EVENT_CLONE = 3" >> ${OUT}
268 if ! grep '^const PTRACE_EVENT_EXEC' ${OUT} > /dev/null 2>&1; then
269 echo "const PTRACE_EVENT_EXEC = 4" >> ${OUT}
271 if ! grep '^const PTRACE_EVENT_VFORK_DONE' ${OUT} > /dev/null 2>&1; then
272 echo "const PTRACE_EVENT_VFORK_DONE = 5" >> ${OUT}
274 if ! grep '^const PTRACE_EVENT_EXIT' ${OUT} > /dev/null 2>&1; then
275 echo "const PTRACE_EVENT_EXIT = 6" >> ${OUT}
277 if ! grep '^const _PTRACE_TRACEME' ${OUT} > /dev/null 2>&1; then
278 echo "const _PTRACE_TRACEME = 0" >> ${OUT}
281 # A helper function that prints a structure from gen-sysinfo.go with the first
282 # letter of the field names in upper case. $1 is the name of structure. If $2
283 # is not empty, the structure or type is renamed to $2.
284 upcase_fields () {
285 name="$1"
286 def=`grep "^type $name " gen-sysinfo.go`
287 fields=`echo $def | sed -e 's/^[^{]*{\(.*\)}$/\1/'`
288 prefix=`echo $def | sed -e 's/{.*//'`
289 if test "$2" != ""; then
290 prefix=`echo $prefix | sed -e "s/$1/$2/"`
292 if test "$fields" != ""; then
293 nfields=
294 while test -n "$fields"; do
295 field=`echo $fields | sed -e 's/^\([^;]*\);.*$/\1/'`
296 fields=`echo $fields | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
297 # capitalize the next character.
298 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
299 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
300 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
301 field="$f$r"
302 nfields="$nfields $field;"
303 done
304 echo "${prefix} {$nfields }"
308 # The registers returned by PTRACE_GETREGS. This is probably
309 # GNU/Linux specific; it should do no harm if there is no
310 # _user_regs_struct.
311 regs=`grep '^type _user_regs_struct struct' gen-sysinfo.go || true`
312 if test "$regs" = ""; then
313 # s390
314 regs=`grep '^type __user_regs_struct struct' gen-sysinfo.go || true`
315 if test "$regs" != ""; then
316 # Substructures of __user_regs_struct on s390
317 upcase_fields "__user_psw_struct" "PtracePsw" >> ${OUT} || true
318 upcase_fields "__user_fpregs_struct" "PtraceFpregs" >> ${OUT} || true
319 upcase_fields "__user_per_struct" "PtracePer" >> ${OUT} || true
322 if test "$regs" != ""; then
323 regs=`echo $regs |
324 sed -e 's/type __*user_regs_struct struct //' -e 's/[{}]//g'`
325 regs=`echo $regs | sed -e s'/^ *//'`
326 nregs=
327 while test -n "$regs"; do
328 field=`echo $regs | sed -e 's/^\([^;]*\);.*$/\1/'`
329 regs=`echo $regs | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
330 # Capitalize the first character of the field.
331 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
332 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
333 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
334 field="$f$r"
335 field=`echo "$field" | sed \
336 -e 's/__user_psw_struct/PtracePsw/' \
337 -e 's/__user_fpregs_struct/PtraceFpregs/' \
338 -e 's/__user_per_struct/PtracePer/'`
339 nregs="$nregs $field;"
340 done
341 echo "type PtraceRegs struct {$nregs }" >> ${OUT}
344 # Some basic types.
345 echo 'type Size_t _size_t' >> ${OUT}
346 echo "type Ssize_t _ssize_t" >> ${OUT}
347 if grep '^const _HAVE_OFF64_T = ' gen-sysinfo.go > /dev/null 2>&1; then
348 echo "type Offset_t _off64_t" >> ${OUT}
349 else
350 echo "type Offset_t _off_t" >> ${OUT}
352 echo "type Mode_t _mode_t" >> ${OUT}
353 echo "type Pid_t _pid_t" >> ${OUT}
354 echo "type Uid_t _uid_t" >> ${OUT}
355 echo "type Gid_t _gid_t" >> ${OUT}
356 echo "type Socklen_t _socklen_t" >> ${OUT}
358 # The C int type.
359 sizeof_int=`grep '^const ___SIZEOF_INT__ = ' gen-sysinfo.go | sed -e 's/.*= //'`
360 if test "$sizeof_int" = "4"; then
361 echo "type _C_int int32" >> ${OUT}
362 echo "type _C_uint uint32" >> ${OUT}
363 elif test "$sizeof_int" = "8"; then
364 echo "type _C_int int64" >> ${OUT}
365 echo "type _C_uint uint64" >> ${OUT}
366 else
367 echo 1>&2 "mksysinfo.sh: could not determine size of int (got $sizeof_int)"
368 exit 1
371 # The C long type, needed because that is the type that ptrace returns.
372 sizeof_long=`grep '^const ___SIZEOF_LONG__ = ' gen-sysinfo.go | sed -e 's/.*= //'`
373 if test "$sizeof_long" = "4"; then
374 echo "type _C_long int32" >> ${OUT}
375 echo "type _C_ulong uint32" >> ${OUT}
376 elif test "$sizeof_long" = "8"; then
377 echo "type _C_long int64" >> ${OUT}
378 echo "type _C_ulong uint64" >> ${OUT}
379 else
380 echo 1>&2 "mksysinfo.sh: could not determine size of long (got $sizeof_long)"
381 exit 1
384 # Solaris 2 needs _u?pad128_t, but its default definition in terms of long
385 # double is commented by -fdump-go-spec.
386 if grep "^// type _pad128_t" gen-sysinfo.go > /dev/null 2>&1; then
387 echo "type _pad128_t struct { _l [4]int32; }" >> ${OUT}
389 if grep "^// type _upad128_t" gen-sysinfo.go > /dev/null 2>&1; then
390 echo "type _upad128_t struct { _l [4]uint32; }" >> ${OUT}
393 # The time_t type.
394 if grep '^type _time_t ' gen-sysinfo.go > /dev/null 2>&1; then
395 echo 'type Time_t _time_t' >> ${OUT}
398 # The time structures need special handling: we need to name the
399 # types, so that we can cast integers to the right types when
400 # assigning to the structures.
401 timeval=`grep '^type _timeval ' gen-sysinfo.go`
402 timeval_sec=`echo $timeval | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
403 timeval_usec=`echo $timeval | sed -n -e 's/^.*tv_usec \([^ ]*\);.*$/\1/p'`
404 echo "type Timeval_sec_t $timeval_sec" >> ${OUT}
405 echo "type Timeval_usec_t $timeval_usec" >> ${OUT}
406 echo $timeval | \
407 sed -e 's/type _timeval /type Timeval /' \
408 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timeval_sec_t/' \
409 -e 's/tv_usec *[a-zA-Z0-9_]*/Usec Timeval_usec_t/' >> ${OUT}
410 timespec=`grep '^type _timespec ' gen-sysinfo.go || true`
411 if test "$timespec" = ""; then
412 # IRIX 6.5 has __timespec instead.
413 timespec=`grep '^type ___timespec ' gen-sysinfo.go || true`
415 timespec_sec=`echo $timespec | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
416 timespec_nsec=`echo $timespec | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
417 echo "type Timespec_sec_t $timespec_sec" >> ${OUT}
418 echo "type Timespec_nsec_t $timespec_nsec" >> ${OUT}
419 echo $timespec | \
420 sed -e 's/^type ___timespec /type Timespec /' \
421 -e 's/^type _timespec /type Timespec /' \
422 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timespec_sec_t/' \
423 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timespec_nsec_t/' >> ${OUT}
425 timestruc=`grep '^type _timestruc_t ' gen-sysinfo.go || true`
426 if test "$timestruc" != ""; then
427 timestruc_sec=`echo $timestruc | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
428 timestruc_nsec=`echo $timestruc | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
429 echo "type Timestruc_sec_t $timestruc_sec" >> ${OUT}
430 echo "type Timestruc_nsec_t $timestruc_nsec" >> ${OUT}
431 echo $timestruc | \
432 sed -e 's/^type _timestruc_t /type Timestruc /' \
433 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timestruc_sec_t/' \
434 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timestruc_nsec_t/' >> ${OUT}
437 # The tms struct.
438 grep '^type _tms ' gen-sysinfo.go | \
439 sed -e 's/type _tms/type Tms/' \
440 -e 's/tms_utime/Utime/' \
441 -e 's/tms_stime/Stime/' \
442 -e 's/tms_cutime/Cutime/' \
443 -e 's/tms_cstime/Cstime/' \
444 >> ${OUT}
446 # The stat type.
447 # Prefer largefile variant if available.
448 stat=`grep '^type _stat64 ' gen-sysinfo.go || true`
449 if test "$stat" != ""; then
450 grep '^type _stat64 ' gen-sysinfo.go
451 else
452 grep '^type _stat ' gen-sysinfo.go
453 fi | sed -e 's/type _stat64/type Stat_t/' \
454 -e 's/type _stat/type Stat_t/' \
455 -e 's/st_dev/Dev/' \
456 -e 's/st_ino/Ino/g' \
457 -e 's/st_nlink/Nlink/' \
458 -e 's/st_mode/Mode/' \
459 -e 's/st_uid/Uid/' \
460 -e 's/st_gid/Gid/' \
461 -e 's/st_rdev/Rdev/' \
462 -e 's/st_size/Size/' \
463 -e 's/st_blksize/Blksize/' \
464 -e 's/st_blocks/Blocks/' \
465 -e 's/st_atim/Atim/' \
466 -e 's/st_mtim/Mtim/' \
467 -e 's/st_ctim/Ctim/' \
468 -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
469 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
470 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
471 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
472 -e 's/Godump_[0-9] struct { \([^;]*;\) };/\1/g' \
473 >> ${OUT}
475 # The directory searching types.
476 # Prefer largefile variant if available.
477 dirent=`grep '^type _dirent64 ' gen-sysinfo.go || true`
478 if test "$dirent" != ""; then
479 grep '^type _dirent64 ' gen-sysinfo.go
480 else
481 grep '^type _dirent ' gen-sysinfo.go
482 fi | sed -e 's/type _dirent64/type Dirent/' \
483 -e 's/type _dirent/type Dirent/' \
484 -e 's/d_name \[0+1\]/d_name [0+256]/' \
485 -e 's/d_name/Name/' \
486 -e 's/]int8/]byte/' \
487 -e 's/d_ino/Ino/' \
488 -e 's/d_off/Off/' \
489 -e 's/d_reclen/Reclen/' \
490 -e 's/d_type/Type/' \
491 >> ${OUT}
492 echo "type DIR _DIR" >> ${OUT}
494 # Values for d_type field in dirent.
495 grep '^const _DT_' gen-sysinfo.go |
496 sed -e 's/^\(const \)_\(DT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
498 # The rusage struct.
499 rusage=`grep '^type _rusage struct' gen-sysinfo.go`
500 if test "$rusage" != ""; then
501 # Remove anonymous unions from GNU/Linux <bits/resource.h>.
502 rusage=`echo $rusage | sed -e 's/Godump_[0-9][0-9]* struct {\([^}]*\)};/\1/g'`
503 rusage=`echo $rusage | sed -e 's/type _rusage struct //' -e 's/[{}]//g'`
504 rusage=`echo $rusage | sed -e 's/^ *//'`
505 nrusage=
506 while test -n "$rusage"; do
507 field=`echo $rusage | sed -e 's/^\([^;]*\);.*$/\1/'`
508 rusage=`echo $rusage | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
509 # Drop the leading ru_, capitalize the next character.
510 field=`echo $field | sed -e 's/^ru_//'`
511 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
512 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
513 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
514 # Fix _timeval _timespec, and _timestruc_t.
515 r=`echo $r | sed -e s'/ _timeval$/ Timeval/'`
516 r=`echo $r | sed -e s'/ _timespec$/ Timespec/'`
517 r=`echo $r | sed -e s'/ _timestruc_t$/ Timestruc/'`
518 field="$f$r"
519 nrusage="$nrusage $field;"
520 done
521 echo "type Rusage struct {$nrusage }" >> ${OUT}
522 else
523 echo "type Rusage struct {}" >> ${OUT}
526 # The RUSAGE constants.
527 grep '^const _RUSAGE_' gen-sysinfo.go | \
528 sed -e 's/^\(const \)_\(RUSAGE_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
530 # The utsname struct.
531 grep '^type _utsname ' gen-sysinfo.go | \
532 sed -e 's/_utsname/Utsname/' \
533 -e 's/sysname/Sysname/' \
534 -e 's/nodename/Nodename/' \
535 -e 's/release/Release/' \
536 -e 's/version/Version/' \
537 -e 's/machine/Machine/' \
538 -e 's/domainname/Domainname/' \
539 >> ${OUT}
541 # The iovec struct.
542 iovec=`grep '^type _iovec ' gen-sysinfo.go`
543 iovec_len=`echo $iovec | sed -n -e 's/^.*iov_len \([^ ]*\);.*$/\1/p'`
544 echo "type Iovec_len_t $iovec_len" >> ${OUT}
545 echo $iovec | \
546 sed -e 's/_iovec/Iovec/' \
547 -e 's/iov_base/Base/' \
548 -e 's/iov_len *[a-zA-Z0-9_]*/Len Iovec_len_t/' \
549 >> ${OUT}
551 # The msghdr struct.
552 msghdr=`grep '^type _msghdr ' gen-sysinfo.go`
553 msghdr_controllen=`echo $msghdr | sed -n -e 's/^.*msg_controllen \([^ ]*\);.*$/\1/p'`
554 echo "type Msghdr_controllen_t $msghdr_controllen" >> ${OUT}
555 echo $msghdr | \
556 sed -e 's/_msghdr/Msghdr/' \
557 -e 's/msg_name/Name/' \
558 -e 's/msg_namelen/Namelen/' \
559 -e 's/msg_iov/Iov/' \
560 -e 's/msg_iovlen/Iovlen/' \
561 -e 's/_iovec/Iovec/' \
562 -e 's/msg_control/Control/' \
563 -e 's/msg_controllen *[a-zA-Z0-9_]*/Controllen Msghdr_controllen_t/' \
564 -e 's/msg_flags/Flags/' \
565 >> ${OUT}
567 # The MSG_ flags for Msghdr.
568 grep '^const _MSG_' gen-sysinfo.go | \
569 sed -e 's/^\(const \)_\(MSG_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
571 # The cmsghdr struct.
572 cmsghdr=`grep '^type _cmsghdr ' gen-sysinfo.go`
573 if test -n "$cmsghdr"; then
574 cmsghdr_len=`echo $cmsghdr | sed -n -e 's/^.*cmsg_len \([^ ]*\);.*$/\1/p'`
575 echo "type Cmsghdr_len_t $cmsghdr_len" >> ${OUT}
576 echo "$cmsghdr" | \
577 sed -e 's/_cmsghdr/Cmsghdr/' \
578 -e 's/cmsg_len *[a-zA-Z0-9_]*/Len Cmsghdr_len_t/' \
579 -e 's/cmsg_level/Level/' \
580 -e 's/cmsg_type/Type/' \
581 -e 's/\[\]/[0]/' \
582 >> ${OUT}
585 # The SCM_ flags for Cmsghdr.
586 grep '^const _SCM_' gen-sysinfo.go | \
587 sed -e 's/^\(const \)_\(SCM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
589 # The ucred struct.
590 upcase_fields "_ucred" "Ucred" >> ${OUT} || true
592 # The ip_mreq struct.
593 grep '^type _ip_mreq ' gen-sysinfo.go | \
594 sed -e 's/_ip_mreq/IPMreq/' \
595 -e 's/imr_multiaddr/Multiaddr/' \
596 -e 's/imr_interface/Interface/' \
597 -e 's/_in_addr/[4]byte/g' \
598 >> ${OUT}
600 # We need IPMreq to compile the net package.
601 if ! grep 'type IPMreq ' ${OUT} >/dev/null 2>&1; then
602 echo 'type IPMreq struct { Multiaddr [4]byte; Interface [4]byte; }' >> ${OUT}
605 # The ipv6_mreq struct.
606 grep '^type _ipv6_mreq ' gen-sysinfo.go | \
607 sed -e 's/_ipv6_mreq/IPv6Mreq/' \
608 -e 's/ipv6mr_multiaddr/Multiaddr/' \
609 -e 's/ipv6mr_interface/Interface/' \
610 -e 's/_in6_addr/[16]byte/' \
611 >> ${OUT}
613 # We need IPv6Mreq to compile the net package.
614 if ! grep 'type IPv6Mreq ' ${OUT} >/dev/null 2>&1; then
615 echo 'type IPv6Mreq struct { Multiaddr [16]byte; Interface uint32; }' >> ${OUT}
618 # The ip_mreqn struct.
619 grep '^type _ip_mreqn ' gen-sysinfo.go | \
620 sed -e 's/_ip_mreqn/IPMreqn/' \
621 -e 's/imr_multiaddr/Multiaddr/' \
622 -e 's/imr_address/Address/' \
623 -e 's/imr_ifindex/Ifindex/' \
624 -e 's/_in_addr/[4]byte/g' \
625 >> ${OUT}
627 # We need IPMreq to compile the net package.
628 if ! grep 'type IPMreqn ' ${OUT} >/dev/null 2>&1; then
629 echo 'type IPMreqn struct { Multiaddr [4]byte; Interface [4]byte; Ifindex int32 }' >> ${OUT}
632 # The icmp6_filter struct.
633 grep '^type _icmp6_filter ' gen-sysinfo.go | \
634 sed -e 's/_icmp6_filter/ICMPv6Filter/' \
635 -e 's/data/Data/' \
636 -e 's/filt/Filt/' \
637 >> ${OUT}
639 # We need ICMPv6Filter to compile the syscall package.
640 if ! grep 'type ICMPv6Filter ' ${OUT} > /dev/null 2>&1; then
641 echo 'type ICMPv6Filter struct { Data [8]uint32 }' >> ${OUT}
644 # The ip6_mtuinfo struct.
645 grep '^type _ip6_mtuinfo ' gen-sysinfo.go | \
646 sed -e 's/_ip6_mtuinfo/IPv6MTUInfo/' \
647 -e 's/ip6m_addr/Addr/' \
648 -e 's/_sockaddr_in6/RawSockaddrInet6/' \
649 -e 's/ip6m_mtu/Mtu/' \
650 >> ${OUT}
652 # Try to guess the type to use for fd_set.
653 fd_set=`grep '^type _fd_set ' gen-sysinfo.go || true`
654 fds_bits_type="_C_long"
655 if test "$fd_set" != ""; then
656 fds_bits_type=`echo $fd_set | sed -e 's/.*[]]\([^;]*\); }$/\1/'`
658 echo "type fds_bits_type $fds_bits_type" >> ${OUT}
660 # The addrinfo struct.
661 grep '^type _addrinfo ' gen-sysinfo.go | \
662 sed -e 's/_addrinfo/Addrinfo/g' \
663 -e 's/ ai_/ Ai_/g' \
664 >> ${OUT}
666 # The addrinfo and nameinfo flags and errors.
667 grep '^const _AI_' gen-sysinfo.go | \
668 sed -e 's/^\(const \)_\(AI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
669 grep '^const _EAI_' gen-sysinfo.go | \
670 sed -e 's/^\(const \)_\(EAI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
671 grep '^const _NI_' gen-sysinfo.go | \
672 sed -e 's/^\(const \)_\(NI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
674 # If nothing else defined EAI_OVERFLOW, make sure it has a value.
675 if ! grep "const EAI_OVERFLOW " ${OUT} >/dev/null 2>&1; then
676 echo "const EAI_OVERFLOW = 0" >> ${OUT}
679 # The passwd struct.
680 grep '^type _passwd ' gen-sysinfo.go | \
681 sed -e 's/_passwd/Passwd/' \
682 -e 's/ pw_/ Pw_/g' \
683 >> ${OUT}
685 # The group struct.
686 grep '^type _group ' gen-sysinfo.go | \
687 sed -e 's/_group/Group/' \
688 -e 's/ gr_/ Gr_/g' \
689 >> ${OUT}
691 # The ioctl flags for the controlling TTY.
692 grep '^const _TIOC' gen-sysinfo.go | \
693 grep -v '_val =' | \
694 sed -e 's/^\(const \)_\(TIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
695 grep '^const _TUNSET' gen-sysinfo.go | \
696 grep -v '_val =' | \
697 sed -e 's/^\(const \)_\(TUNSET[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
698 # We need TIOCGWINSZ.
699 if ! grep '^const TIOCGWINSZ' ${OUT} >/dev/null 2>&1; then
700 if grep '^const _TIOCGWINSZ_val' ${OUT} >/dev/null 2>&1; then
701 echo 'const TIOCGWINSZ = _TIOCGWINSZ_val' >> ${OUT}
704 if ! grep '^const TIOCSWINSZ' ${OUT} >/dev/null 2>&1; then
705 if grep '^const _TIOCSWINSZ_val' ${OUT} >/dev/null 2>&1; then
706 echo 'const TIOCSWINSZ = _TIOCSWINSZ_val' >> ${OUT}
709 if ! grep '^const TIOCNOTTY' ${OUT} >/dev/null 2>&1; then
710 if grep '^const _TIOCNOTTY_val' ${OUT} >/dev/null 2>&1; then
711 echo 'const TIOCNOTTY = _TIOCNOTTY_val' >> ${OUT}
714 if ! grep '^const TIOCSCTTY' ${OUT} >/dev/null 2>&1; then
715 if grep '^const _TIOCSCTTY_val' ${OUT} >/dev/null 2>&1; then
716 echo 'const TIOCSCTTY = _TIOCSCTTY_val' >> ${OUT}
719 if ! grep '^const TIOCGPGRP' ${OUT} >/dev/null 2>&1; then
720 if grep '^const _TIOCGPGRP_val' ${OUT} >/dev/null 2>&1; then
721 echo 'const TIOCGPGRP = _TIOCGPGRP_val' >> ${OUT}
724 if ! grep '^const TIOCSPGRP' ${OUT} >/dev/null 2>&1; then
725 if grep '^const _TIOCSPGRP_val' ${OUT} >/dev/null 2>&1; then
726 echo 'const TIOCSPGRP = _TIOCSPGRP_val' >> ${OUT}
729 if ! grep '^const TIOCGPTN' ${OUT} >/dev/null 2>&1; then
730 if grep '^const _TIOCGPTN_val' ${OUT} >/dev/null 2>&1; then
731 echo 'const TIOCGPTN = _TIOCGPTN_val' >> ${OUT}
734 if ! grep '^const TIOCSPTLCK' ${OUT} >/dev/null 2>&1; then
735 if grep '^const _TIOCSPTLCK_val' ${OUT} >/dev/null 2>&1; then
736 echo 'const TIOCSPTLCK = _TIOCSPTLCK_val' >> ${OUT}
739 if ! grep '^const TIOCGDEV' ${OUT} >/dev/null 2>&1; then
740 if grep '^const _TIOCGDEV_val' ${OUT} >/dev/null 2>&1; then
741 echo 'const TIOCGDEV = _TIOCGDEV_val' >> ${OUT}
744 if ! grep '^const TIOCSIG' ${OUT} >/dev/null 2>&1; then
745 if grep '^const _TIOCSIG_val' ${OUT} >/dev/null 2>&1; then
746 echo 'const TIOCSIG = _TIOCSIG_val' >> ${OUT}
750 if ! grep '^const TUNSETNOCSUM' ${OUT} >/dev/null 2>&1; then
751 if grep '^const _TUNSETNOCSUM_val' ${OUT} >/dev/null 2>&1; then
752 echo 'const TUNSETNOCSUM = _TUNSETNOCSUM_val' >> ${OUT}
756 if ! grep '^const TUNSETDEBUG' ${OUT} >/dev/null 2>&1; then
757 if grep '^const _TUNSETDEBUG_val' ${OUT} >/dev/null 2>&1; then
758 echo 'const TUNSETDEBUG = _TUNSETDEBUG_val' >> ${OUT}
762 if ! grep '^const TUNSETIFF' ${OUT} >/dev/null 2>&1; then
763 if grep '^const _TUNSETIFF_val' ${OUT} >/dev/null 2>&1; then
764 echo 'const TUNSETIFF = _TUNSETIFF_val' >> ${OUT}
768 if ! grep '^const TUNSETPERSIST' ${OUT} >/dev/null 2>&1; then
769 if grep '^const _TUNSETPERSIST_val' ${OUT} >/dev/null 2>&1; then
770 echo 'const TUNSETPERSIST = _TUNSETPERSIST_val' >> ${OUT}
774 if ! grep '^const TUNSETOWNER' ${OUT} >/dev/null 2>&1; then
775 if grep '^const _TUNSETOWNER_val' ${OUT} >/dev/null 2>&1; then
776 echo 'const TUNSETOWNER = _TUNSETOWNER_val' >> ${OUT}
780 if ! grep '^const TUNSETLINK' ${OUT} >/dev/null 2>&1; then
781 if grep '^const _TUNSETLINK_val' ${OUT} >/dev/null 2>&1; then
782 echo 'const TUNSETLINK = _TUNSETLINK_val' >> ${OUT}
786 if ! grep '^const TUNSETGROUP' ${OUT} >/dev/null 2>&1; then
787 if grep '^const _TUNSETGROUP_val' ${OUT} >/dev/null 2>&1; then
788 echo 'const TUNSETGROUP = _TUNSETGROUP_val' >> ${OUT}
792 if ! grep '^const TUNGETFEATURES' ${OUT} >/dev/null 2>&1; then
793 if grep '^const _TUNGETFEATURES_val' ${OUT} >/dev/null 2>&1; then
794 echo 'const TUNGETFEATURES = _TUNGETFEATURES_val' >> ${OUT}
798 if ! grep '^const TUNSETOFFLOAD' ${OUT} >/dev/null 2>&1; then
799 if grep '^const _TUNSETOFFLOAD_val' ${OUT} >/dev/null 2>&1; then
800 echo 'const TUNSETOFFLOAD = _TUNSETOFFLOAD_val' >> ${OUT}
804 if ! grep '^const TUNSETTXFILTER' ${OUT} >/dev/null 2>&1; then
805 if grep '^const _TUNSETTXFILTER_val' ${OUT} >/dev/null 2>&1; then
806 echo 'const TUNSETTXFILTER = _TUNSETTXFILTER_val' >> ${OUT}
810 if ! grep '^const TUNGETIFF' ${OUT} >/dev/null 2>&1; then
811 if grep '^const _TUNGETIFF_val' ${OUT} >/dev/null 2>&1; then
812 echo 'const TUNGETIFF = _TUNGETIFF_val' >> ${OUT}
816 if ! grep '^const TUNGETSNDBUF' ${OUT} >/dev/null 2>&1; then
817 if grep '^const _TUNGETSNDBUF_val' ${OUT} >/dev/null 2>&1; then
818 echo 'const TUNGETSNDBUF = _TUNGETSNDBUF_val' >> ${OUT}
822 if ! grep '^const TUNSETSNDBUF' ${OUT} >/dev/null 2>&1; then
823 if grep '^const _TUNSETSNDBUF_val' ${OUT} >/dev/null 2>&1; then
824 echo 'const TUNSETSNDBUF = _TUNSETSNDBUF_val' >> ${OUT}
828 if ! grep '^const TUNATTACHFILTER' ${OUT} >/dev/null 2>&1; then
829 if grep '^const _TUNATTACHFILTER_val' ${OUT} >/dev/null 2>&1; then
830 echo 'const TUNATTACHFILTER = _TUNATTACHFILTER_val' >> ${OUT}
834 if ! grep '^const TUNDETACHFILTER' ${OUT} >/dev/null 2>&1; then
835 if grep '^const _TUNDETACHFILTER_val' ${OUT} >/dev/null 2>&1; then
836 echo 'const TUNDETACHFILTER = _TUNDETACHFILTER_val' >> ${OUT}
840 if ! grep '^const TUNGETVNETHDRSZ' ${OUT} >/dev/null 2>&1; then
841 if grep '^const _TUNGETVNETHDRSZ_val' ${OUT} >/dev/null 2>&1; then
842 echo 'const TUNGETVNETHDRSZ = _TUNGETVNETHDRSZ_val' >> ${OUT}
846 if ! grep '^const TUNSETVNETHDRSZ' ${OUT} >/dev/null 2>&1; then
847 if grep '^const _TUNSETVNETHDRSZ_val' ${OUT} >/dev/null 2>&1; then
848 echo 'const TUNSETVNETHDRSZ = _TUNSETVNETHDRSZ_val' >> ${OUT}
852 if ! grep '^const TUNSETQUEUE' ${OUT} >/dev/null 2>&1; then
853 if grep '^const _TUNSETQUEUE_val' ${OUT} >/dev/null 2>&1; then
854 echo 'const TUNSETQUEUE = _TUNSETQUEUE_val' >> ${OUT}
859 if ! grep '^const TUNSETIFINDEX' ${OUT} >/dev/null 2>&1; then
860 if grep '^const _TUNSETIFINDEX_val' ${OUT} >/dev/null 2>&1; then
861 echo 'const TUNSETIFINDEX = _TUNSETIFINDEX_val' >> ${OUT}
865 if ! grep '^const TUNGETFILTER' ${OUT} >/dev/null 2>&1; then
866 if grep '^const _TUNGETFILTER_val' ${OUT} >/dev/null 2>&1; then
867 echo 'const TUNGETFILTER = _TUNGETFILTER_val' >> ${OUT}
871 # The ioctl flags for terminal control
872 grep '^const _TC[GS]ET' gen-sysinfo.go | grep -v _val | \
873 sed -e 's/^\(const \)_\(TC[GS]ET[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
874 if ! grep '^const TCGETS' ${OUT} >/dev/null 2>&1; then
875 if grep '^const _TCGETS_val' ${OUT} >/dev/null 2>&1; then
876 echo 'const TCGETS = _TCGETS_val' >> ${OUT}
879 if ! grep '^const TCSETS' ${OUT} >/dev/null 2>&1; then
880 if grep '^const _TCSETS_val' ${OUT} >/dev/null 2>&1; then
881 echo 'const TCSETS = _TCSETS_val' >> ${OUT}
885 # ioctl constants. Might fall back to 0 if TIOCNXCL is missing, too, but
886 # needs handling in syscalls.exec.go.
887 if ! grep '^const _TIOCSCTTY ' gen-sysinfo.go >/dev/null 2>&1; then
888 if grep '^const _TIOCNXCL ' gen-sysinfo.go >/dev/null 2>&1; then
889 echo "const TIOCSCTTY = TIOCNXCL" >> ${OUT}
893 # If nothing else defined TIOCSCTTY, make sure it has a value.
894 if ! grep "const TIOCSCTTY " ${OUT} >/dev/null 2>&1; then
895 echo "const TIOCSCTTY = 0" >> ${OUT}
898 # The nlmsghdr struct.
899 grep '^type _nlmsghdr ' gen-sysinfo.go | \
900 sed -e 's/_nlmsghdr/NlMsghdr/' \
901 -e 's/nlmsg_len/Len/' \
902 -e 's/nlmsg_type/Type/' \
903 -e 's/nlmsg_flags/Flags/' \
904 -e 's/nlmsg_seq/Seq/' \
905 -e 's/nlmsg_pid/Pid/' \
906 >> ${OUT}
908 # The nlmsg flags and operators.
909 grep '^const _NLM' gen-sysinfo.go | \
910 sed -e 's/^\(const \)_\(NLM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
912 # NLMSG_HDRLEN is defined as an expression using sizeof.
913 if ! grep '^const NLMSG_HDRLEN' ${OUT} > /dev/null 2>&1; then
914 if grep '^const _sizeof_nlmsghdr ' ${OUT} > /dev/null 2>&1; then
915 echo 'const NLMSG_HDRLEN = (_sizeof_nlmsghdr + (NLMSG_ALIGNTO-1)) &^ (NLMSG_ALIGNTO-1)' >> ${OUT}
919 # The rtmsg struct.
920 grep '^type _rtmsg ' gen-sysinfo.go | \
921 sed -e 's/_rtmsg/RtMsg/' \
922 -e 's/rtm_family/Family/' \
923 -e 's/rtm_dst_len/Dst_len/' \
924 -e 's/rtm_src_len/Src_len/' \
925 -e 's/rtm_tos/Tos/' \
926 -e 's/rtm_table/Table/' \
927 -e 's/rtm_protocol/Protocol/' \
928 -e 's/rtm_scope/Scope/' \
929 -e 's/rtm_type/Type/' \
930 -e 's/rtm_flags/Flags/' \
931 >> ${OUT}
933 # The rtgenmsg struct.
934 grep '^type _rtgenmsg ' gen-sysinfo.go | \
935 sed -e 's/_rtgenmsg/RtGenmsg/' \
936 -e 's/rtgen_family/Family/' \
937 >> ${OUT}
939 # The routing message flags.
940 grep '^const _RT_' gen-sysinfo.go | \
941 sed -e 's/^\(const \)_\(RT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
942 grep '^const _RTA' gen-sysinfo.go | \
943 sed -e 's/^\(const \)_\(RTA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
944 grep '^const _RTF' gen-sysinfo.go | \
945 sed -e 's/^\(const \)_\(RTF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
946 grep '^const _RTCF' gen-sysinfo.go | \
947 sed -e 's/^\(const \)_\(RTCF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
948 grep '^const _RTM' gen-sysinfo.go | \
949 sed -e 's/^\(const \)_\(RTM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
950 grep '^const _RTN' gen-sysinfo.go | \
951 sed -e 's/^\(const \)_\(RTN[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
952 grep '^const _RTPROT' gen-sysinfo.go | \
953 sed -e 's/^\(const \)_\(RTPROT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
955 # The ifinfomsg struct.
956 grep '^type _ifinfomsg ' gen-sysinfo.go | \
957 sed -e 's/_ifinfomsg/IfInfomsg/' \
958 -e 's/ifi_family/Family/' \
959 -e 's/ifi_type/Type/' \
960 -e 's/ifi_index/Index/' \
961 -e 's/ifi_flags/Flags/' \
962 -e 's/ifi_change/Change/' \
963 >> ${OUT}
965 # The interface information types and flags.
966 grep '^const _IFA' gen-sysinfo.go | \
967 sed -e 's/^\(const \)_\(IFA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
968 grep '^const _IFLA' gen-sysinfo.go | \
969 sed -e 's/^\(const \)_\(IFLA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
970 grep '^const _IFF' gen-sysinfo.go | \
971 sed -e 's/^\(const \)_\(IFF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
972 grep '^const _IFNAMSIZ' gen-sysinfo.go | \
973 sed -e 's/^\(const \)_\(IFNAMSIZ[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
974 grep '^const _SIOC' gen-sysinfo.go |
975 sed -e 's/^\(const \)_\(SIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
977 # The ifaddrmsg struct.
978 grep '^type _ifaddrmsg ' gen-sysinfo.go | \
979 sed -e 's/_ifaddrmsg/IfAddrmsg/' \
980 -e 's/ifa_family/Family/' \
981 -e 's/ifa_prefixlen/Prefixlen/' \
982 -e 's/ifa_flags/Flags/' \
983 -e 's/ifa_scope/Scope/' \
984 -e 's/ifa_index/Index/' \
985 >> ${OUT}
987 # The rtattr struct.
988 grep '^type _rtattr ' gen-sysinfo.go | \
989 sed -e 's/_rtattr/RtAttr/' \
990 -e 's/rta_len/Len/' \
991 -e 's/rta_type/Type/' \
992 >> ${OUT}
994 # The in_pktinfo struct.
995 grep '^type _in_pktinfo ' gen-sysinfo.go | \
996 sed -e 's/_in_pktinfo/Inet4Pktinfo/' \
997 -e 's/ipi_ifindex/Ifindex/' \
998 -e 's/ipi_spec_dst/Spec_dst/' \
999 -e 's/ipi_addr/Addr/' \
1000 -e 's/_in_addr/[4]byte/g' \
1001 >> ${OUT}
1003 # The in6_pktinfo struct.
1004 grep '^type _in6_pktinfo ' gen-sysinfo.go | \
1005 sed -e 's/_in6_pktinfo/Inet6Pktinfo/' \
1006 -e 's/ipi6_addr/Addr/' \
1007 -e 's/ipi6_ifindex/Ifindex/' \
1008 -e 's/_in6_addr/[16]byte/' \
1009 >> ${OUT}
1011 # The termios struct.
1012 grep '^type _termios ' gen-sysinfo.go | \
1013 sed -e 's/_termios/Termios/' \
1014 -e 's/c_iflag/Iflag/' \
1015 -e 's/c_oflag/Oflag/' \
1016 -e 's/c_cflag/Cflag/' \
1017 -e 's/c_lflag/Lflag/' \
1018 -e 's/c_line/Line/' \
1019 -e 's/c_cc/Cc/' \
1020 -e 's/c_ispeed/Ispeed/' \
1021 -e 's/c_ospeed/Ospeed/' \
1022 >> ${OUT}
1024 # The termios constants.
1025 for n in IGNBRK BRKINT IGNPAR PARMRK INPCK ISTRIP INLCR IGNCR ICRNL IUCLC \
1026 IXON IXANY IXOFF IMAXBEL IUTF8 OPOST OLCUC ONLCR OCRNL ONOCR ONLRET \
1027 OFILL OFDEL NLDLY NL0 NL1 CRDLY CR0 CR1 CR2 CR3 CS5 CS6 CS7 CS8 TABDLY \
1028 BSDLY VTDLY FFDLY CBAUD CBAUDEX CSIZE CSTOPB CREAD PARENB PARODD HUPCL \
1029 CLOCAL LOBLK CIBAUD CMSPAR CRTSCTS ISIG ICANON XCASE ECHO ECHOE ECHOK \
1030 ECHONL ECHOCTL ECHOPRT ECHOKE DEFECHO FLUSHO NOFLSH TOSTOP PENDIN IEXTEN \
1031 VINTR VQUIT VERASE VKILL VEOF VMIN VEOL VTIME VEOL2 VSWTCH VSTART VSTOP \
1032 VSUSP VDSUSP VLNEXT VWERASE VREPRINT VDISCARD VSTATUS TCSANOW TCSADRAIN \
1033 TCSAFLUSH TCIFLUSH TCOFLUSH TCIOFLUSH TCOOFF TCOON TCIOFF TCION B0 B50 \
1034 B75 B110 B134 B150 B200 B300 B600 B1200 B1800 B2400 B4800 B9600 B19200 \
1035 B38400 B57600 B115200 B230400 B460800 B500000 B576000 B921600 B1000000 \
1036 B1152000 B1500000 B2000000 B2500000 B3000000 B3500000 B4000000; do
1038 grep "^const _$n " gen-sysinfo.go | \
1039 sed -e 's/^\(const \)_\([^=]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1040 done
1042 # The mount flags
1043 grep '^const _MNT_' gen-sysinfo.go |
1044 sed -e 's/^\(const \)_\(MNT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1045 grep '^const _MS_' gen-sysinfo.go |
1046 sed -e 's/^\(const \)_\(MS_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1048 # The fallocate flags.
1049 grep '^const _FALLOC_' gen-sysinfo.go |
1050 sed -e 's/^\(const \)_\(FALLOC_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1052 # The statfs struct.
1053 # Prefer largefile variant if available.
1054 statfs=`grep '^type _statfs64 ' gen-sysinfo.go || true`
1055 if test "$statfs" != ""; then
1056 grep '^type _statfs64 ' gen-sysinfo.go
1057 else
1058 grep '^type _statfs ' gen-sysinfo.go
1059 fi | sed -e 's/type _statfs64/type Statfs_t/' \
1060 -e 's/type _statfs/type Statfs_t/' \
1061 -e 's/f_type/Type/' \
1062 -e 's/f_bsize/Bsize/' \
1063 -e 's/f_blocks/Blocks/' \
1064 -e 's/f_bfree/Bfree/' \
1065 -e 's/f_bavail/Bavail/' \
1066 -e 's/f_files/Files/' \
1067 -e 's/f_ffree/Ffree/' \
1068 -e 's/f_fsid/Fsid/' \
1069 -e 's/f_namelen/Namelen/' \
1070 -e 's/f_frsize/Frsize/' \
1071 -e 's/f_flags/Flags/' \
1072 -e 's/f_spare/Spare/' \
1073 >> ${OUT}
1075 # The timex struct.
1076 timex=`grep '^type _timex ' gen-sysinfo.go || true`
1077 if test "$timex" = ""; then
1078 timex=`grep '^// type _timex ' gen-sysinfo.go || true`
1079 if test "$timex" != ""; then
1080 timex=`echo $timex | sed -e 's|// ||' -e 's/INVALID-bit-field/int32/g'`
1083 if test "$timex" != ""; then
1084 echo "$timex" | \
1085 sed -e 's/_timex/Timex/' \
1086 -e 's/modes/Modes/' \
1087 -e 's/offset/Offset/' \
1088 -e 's/freq/Freq/' \
1089 -e 's/maxerror/Maxerror/' \
1090 -e 's/esterror/Esterror/' \
1091 -e 's/status/Status/' \
1092 -e 's/constant/Constant/' \
1093 -e 's/precision/Precision/' \
1094 -e 's/tolerance/Tolerance/' \
1095 -e 's/ time / Time /' \
1096 -e 's/tick/Tick/' \
1097 -e 's/ppsfreq/Ppsfreq/' \
1098 -e 's/jitter/Jitter/' \
1099 -e 's/shift/Shift/' \
1100 -e 's/stabil/Stabil/' \
1101 -e 's/jitcnt/Jitcnt/' \
1102 -e 's/calcnt/Calcnt/' \
1103 -e 's/errcnt/Errcnt/' \
1104 -e 's/stbcnt/Stbcnt/' \
1105 -e 's/tai/Tai/' \
1106 -e 's/_timeval/Timeval/' \
1107 >> ${OUT}
1110 # The rlimit struct.
1111 grep '^type _rlimit ' gen-sysinfo.go | \
1112 sed -e 's/_rlimit/Rlimit/' \
1113 -e 's/rlim_cur/Cur/' \
1114 -e 's/rlim_max/Max/' \
1115 >> ${OUT}
1117 # The RLIMIT constants.
1118 grep '^const _RLIMIT_' gen-sysinfo.go |
1119 sed -e 's/^\(const \)_\(RLIMIT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1120 grep '^const _RLIM_' gen-sysinfo.go |
1121 sed -e 's/^\(const \)_\(RLIM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1123 # The sysinfo struct.
1124 grep '^type _sysinfo ' gen-sysinfo.go | \
1125 sed -e 's/_sysinfo/Sysinfo_t/' \
1126 -e 's/uptime/Uptime/' \
1127 -e 's/loads/Loads/' \
1128 -e 's/totalram/Totalram/' \
1129 -e 's/freeram/Freeram/' \
1130 -e 's/sharedram/Sharedram/' \
1131 -e 's/bufferram/Bufferram/' \
1132 -e 's/totalswap/Totalswap/' \
1133 -e 's/freeswap/Freeswap/' \
1134 -e 's/procs/Procs/' \
1135 -e 's/totalhigh/Totalhigh/' \
1136 -e 's/freehigh/Freehigh/' \
1137 -e 's/mem_unit/Unit/' \
1138 >> ${OUT}
1140 # The ustat struct.
1141 grep '^type _ustat ' gen-sysinfo.go | \
1142 sed -e 's/_ustat/Ustat_t/' \
1143 -e 's/f_tfree/Tfree/' \
1144 -e 's/f_tinode/Tinoe/' \
1145 -e 's/f_fname/Fname/' \
1146 -e 's/f_fpack/Fpack/' \
1147 >> ${OUT}
1148 # Force it to be defined, as on some older GNU/Linux systems the
1149 # header file fails when using with <linux/filter.h>.
1150 if ! grep 'type _ustat ' gen-sysinfo.go >/dev/null 2>&1; then
1151 echo 'type Ustat_t struct { Tfree int32; Tinoe uint64; Fname [5+1]int8; Fpack [5+1]int8; }' >> ${OUT}
1154 # The utimbuf struct.
1155 grep '^type _utimbuf ' gen-sysinfo.go | \
1156 sed -e 's/_utimbuf/Utimbuf/' \
1157 -e 's/actime/Actime/' \
1158 -e 's/modtime/Modtime/' \
1159 >> ${OUT}
1161 # The LOCK flags for flock.
1162 grep '^const _LOCK_' gen-sysinfo.go |
1163 sed -e 's/^\(const \)_\(LOCK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1165 # The PRIO constants.
1166 grep '^const _PRIO_' gen-sysinfo.go | \
1167 sed -e 's/^\(const \)_\(PRIO_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1169 # The GNU/Linux LINUX_REBOOT flags.
1170 grep '^const _LINUX_REBOOT_' gen-sysinfo.go |
1171 sed -e 's/^\(const \)_\(LINUX_REBOOT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1173 # The GNU/Linux sock_filter struct.
1174 grep '^type _sock_filter ' gen-sysinfo.go | \
1175 sed -e 's/_sock_filter/SockFilter/' \
1176 -e 's/code/Code/' \
1177 -e 's/jt/Jt/' \
1178 -e 's/jf/Jf/' \
1179 -e 's/k /K /' \
1180 >> ${OUT}
1182 # The GNU/Linux sock_fprog struct.
1183 grep '^type _sock_fprog ' gen-sysinfo.go | \
1184 sed -e 's/_sock_fprog/SockFprog/' \
1185 -e 's/len/Len/' \
1186 -e 's/filter/Filter/' \
1187 -e 's/_sock_filter/SockFilter/' \
1188 >> ${OUT}
1190 # The GNU/Linux filter flags.
1191 grep '^const _BPF_' gen-sysinfo.go | \
1192 sed -e 's/^\(const \)_\(BPF_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1194 # The GNU/Linux nlattr struct.
1195 grep '^type _nlattr ' gen-sysinfo.go | \
1196 sed -e 's/_nlattr/NlAttr/' \
1197 -e 's/nla_len/Len/' \
1198 -e 's/nla_type/Type/' \
1199 >> ${OUT}
1201 # The GNU/Linux nlmsgerr struct.
1202 grep '^type _nlmsgerr ' gen-sysinfo.go | \
1203 sed -e 's/_nlmsgerr/NlMsgerr/' \
1204 -e 's/error/Error/' \
1205 -e 's/msg/Msg/' \
1206 -e 's/_nlmsghdr/NlMsghdr/' \
1207 >> ${OUT}
1209 # The GNU/Linux rtnexthop struct.
1210 grep '^type _rtnexthop ' gen-sysinfo.go | \
1211 sed -e 's/_rtnexthop/RtNexthop/' \
1212 -e 's/rtnh_len/Len/' \
1213 -e 's/rtnh_flags/Flags/' \
1214 -e 's/rtnh_hops/Hops/' \
1215 -e 's/rtnh_ifindex/Ifindex/' \
1216 >> ${OUT}
1218 # The GNU/Linux netlink flags.
1219 grep '^const _NETLINK_' gen-sysinfo.go | \
1220 sed -e 's/^\(const \)_\(NETLINK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1221 grep '^const _NLA_' gen-sysinfo.go | grep -v '_val =' | \
1222 sed -e 's/^\(const \)_\(NLA_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1224 if ! grep '^const NLA_HDRLEN' ${OUT} >/dev/null 2>&1; then
1225 if grep '^const _NLA_HDRLEN_val' ${OUT} >/dev/null 2>&1; then
1226 echo 'const NLA_HDRLEN = _NLA_HDRLEN_val' >> ${OUT}
1230 # The GNU/Linux packet socket flags.
1231 grep '^const _PACKET_' gen-sysinfo.go | \
1232 sed -e 's/^\(const \)_\(PACKET_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1234 # The GNU/Linux inotify_event struct.
1235 grep '^type _inotify_event ' gen-sysinfo.go | \
1236 sed -e 's/_inotify_event/InotifyEvent/' \
1237 -e 's/wd/Wd/' \
1238 -e 's/mask/Mask/' \
1239 -e 's/cookie/Cookie/' \
1240 -e 's/len/Len/' \
1241 -e 's/name/Name/' \
1242 -e 's/\[\]/[0]/' \
1243 -e 's/\[0\]byte/[0]int8/' \
1244 >> ${OUT}
1246 # The GNU/Linux CLONE flags.
1247 grep '^const _CLONE_' gen-sysinfo.go | \
1248 sed -e 's/^\(const \)_\(CLONE_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1249 # We need some CLONE constants that are not defined in older versions
1250 # of glibc.
1251 if ! grep '^const CLONE_NEWUSER ' ${OUT} > /dev/null 2>&1; then
1252 echo "const CLONE_NEWUSER = 0x10000000" >> ${OUT}
1254 if ! grep '^const CLONE_NEWNET ' ${OUT} > /dev/null 2>&1; then
1255 echo "const CLONE_NEWNET = 0x40000000" >> ${OUT}
1258 # Struct sizes.
1259 set cmsghdr Cmsghdr ip_mreq IPMreq ip_mreqn IPMreqn ipv6_mreq IPv6Mreq \
1260 ifaddrmsg IfAddrmsg ifinfomsg IfInfomsg in_pktinfo Inet4Pktinfo \
1261 in6_pktinfo Inet6Pktinfo inotify_event InotifyEvent linger Linger \
1262 msghdr Msghdr nlattr NlAttr nlmsgerr NlMsgerr nlmsghdr NlMsghdr \
1263 rtattr RtAttr rtgenmsg RtGenmsg rtmsg RtMsg rtnexthop RtNexthop \
1264 sock_filter SockFilter sock_fprog SockFprog ucred Ucred \
1265 icmp6_filter ICMPv6Filter ip6_mtuinfo IPv6MTUInfo
1266 while test $# != 0; do
1267 nc=$1
1268 ngo=$2
1269 shift
1270 shift
1271 if grep "^const _sizeof_$nc =" gen-sysinfo.go >/dev/null 2>&1; then
1272 echo "const Sizeof$ngo = _sizeof_$nc" >> ${OUT}
1274 done
1276 # In order to compile the net package, we need some sizes to exist
1277 # even if the types do not.
1278 if ! grep 'const SizeofIPMreq ' ${OUT} >/dev/null 2>&1; then
1279 echo 'const SizeofIPMreq = 8' >> ${OUT}
1281 if ! grep 'const SizeofIPv6Mreq ' ${OUT} >/dev/null 2>&1; then
1282 echo 'const SizeofIPv6Mreq = 20' >> ${OUT}
1284 if ! grep 'const SizeofIPMreqn ' ${OUT} >/dev/null 2>&1; then
1285 echo 'const SizeofIPMreqn = 12' >> ${OUT}
1287 if ! grep 'const SizeofICMPv6Filter ' ${OUT} >/dev/null 2>&1; then
1288 echo 'const SizeofICMPv6Filter = 32' >> ${OUT}
1291 # The Solaris 11 Update 1 _zone_net_addr_t struct.
1292 grep '^type _zone_net_addr_t ' gen-sysinfo.go | \
1293 sed -e 's/_in6_addr/[16]byte/' \
1294 >> ${OUT}
1296 # The Solaris 12 _flow_arp_desc_t struct.
1297 grep '^type _flow_arp_desc_t ' gen-sysinfo.go | \
1298 sed -e 's/_in6_addr_t/[16]byte/g' \
1299 >> ${OUT}
1301 # The Solaris 12 _flow_l3_desc_t struct.
1302 grep '^type _flow_l3_desc_t ' gen-sysinfo.go | \
1303 sed -e 's/_in6_addr_t/[16]byte/g' \
1304 >> ${OUT}
1306 # The Solaris 12 _mac_ipaddr_t struct.
1307 grep '^type _mac_ipaddr_t ' gen-sysinfo.go | \
1308 sed -e 's/_in6_addr_t/[16]byte/g' \
1309 >> ${OUT}
1311 # The Solaris 12 _mactun_info_t struct.
1312 grep '^type _mactun_info_t ' gen-sysinfo.go | \
1313 sed -e 's/_in6_addr_t/[16]byte/g' \
1314 >> ${OUT}
1316 exit $?